Summary: Fast compression and decompression utilities
Name: ncompress
Version: 4.2.4.4
Release: 1
License: Public Domain
Group:  Applications/File
URL:    http://ncompress.sourceforge.net/
Source0: http://prdownloads.sourceforge.net/sourceforge/%{name}/%{name}-%{version}.tar.gz

# allow to build ncompress
# ~> downstream
Patch0: %{name}-%{version}-make.patch

# from dist-git commit 0539779d937
# (praiskup: removed redundant part as -DNOFUNCDEF is defined)
# ~> downstream
Patch1: %{name}-%{version}-lfs.patch

# exit when too long filename is given (do not segfault)
# ~> #unknown
# ~> downstream
Patch2: %{name}-%{version}-filenamelen.patch

# permit files > 2GB to be compressed
# ~> #126775
Patch3: %{name}-%{version}-2GB.patch

# do not fail to compress on ppc/s390x
# ~> #207001
Patch4: %{name}-%{version}-endians.patch

# use memmove instead of memcpy
# ~> 760657
# ~> downstream
Patch5: %{name}-%{version}-memmove.patch

# silence gcc warnings
# ~> downstream
Patch6: %{name}-%{version}-silence-gcc.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: coreutils
BuildRequires: patch

%description
The ncompress package contains the compress and uncompress file
compression and decompression utilities, which are compatible with the
original UNIX compress utility (.Z file extensions).  These utilities
can't handle gzipped (.gz file extensions) files, but gzip can handle
compressed files.

Install ncompress if you need compression/decompression utilities
which are compatible with the original UNIX compress utility.


%prep
%setup -q
export PATH=/opt/freeware/bin:$PATH

# configure build system
# ~> downstream
%patch0 -p1 -b .configure-buildsystem

%ifarch sparc m68k armv4l ppc s390 s390x ppc64 sparc64
ARCH_FLAGS="$ARCH_FLAGS -DBYTEORDER=1234"
%endif

%ifarch alpha ia64
ARCH_FLAGS="$ARCH_FLAGS -DNOALLIGN=0"
%endif

sed "s/\$(ARCH_FLAGS)/$ARCH_FLAGS/" Makefile.def > Makefile

%patch1 -p1 -b .lfs
%patch2 -p1 -b .filenamelen
%patch3 -p1 -b .2GB
%patch4 -p1 -b .endians
%patch5 -p1 -b .memmove
%patch6 -p1 -b .silence-gcc


%build
export CC="cc -D_LARGE_FILES"
make
strip compress


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
cp compress ${RPM_BUILD_ROOT}%{_bindir}/
chmod 0755 ${RPM_BUILD_ROOT}%{_bindir}/compress
ln -sf compress ${RPM_BUILD_ROOT}%{_bindir}/uncompress

mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man1
cp compress.1 ${RPM_BUILD_ROOT}%{_mandir}/man1/
chmod 0644 ${RPM_BUILD_ROOT}%{_mandir}/man1/*
ln -sf compress.1 ${RPM_BUILD_ROOT}%{_mandir}/man1/uncompress.1

cd ${RPM_BUILD_ROOT}
mkdir -p usr/linux/bin
cd usr/linux/bin
ln -sf ../../..%{_bindir}/* .


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%doc LZW.INFO README
%{_bindir}/*
%{_mandir}/man1/*
/usr/linux/bin/*


%changelog
* Mon Mar 25 2013 Michael Perzl <michael@perzl.org> - 4.2.4.4-1
- first version for AIX V5.1 and higher
